<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\EmailManager;

use Sylius\Component\Core\Model\OrderInterface;
use Sylius\Component\Mailer\Sender\SenderInterface;

final class VoucherOrderEmailManager implements VoucherOrderEmailManagerInterface
{
    private readonly SenderInterface $sender;

    public function __construct(SenderInterface $sender)
    {
        $this->sender = $sender;
    }

    public function sendEmailWithVouchers(OrderInterface $order, array $vouchers): void
    {
        $customer = $order->getCustomer();
        if (null === $customer) {
            return;
        }

        $email = $customer->getEmail();
        if (null === $email) {
            return;
        }

        $this->sender->send(
            self::EMAIL_CONFIG_NAME,
            [$email],
            ['vouchers' => $vouchers, 'order' => $order],
        );
    }
}
