<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Exception;

use InvalidArgumentException;

final class VoucherNotFoundException extends InvalidArgumentException implements ExceptionInterface
{
    private readonly string $voucher;

    public function __construct(string $voucher)
    {
        parent::__construct(sprintf('The voucher with code "%s" was not found', $voucher));

        $this->voucher = $voucher;
    }

    public function getVoucher(): string
    {
        return $this->voucher;
    }
}
