<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Factory;

use Dedi\SyliusVoucherPlugin\Model\VoucherConfigurationImageInterface;
use Dedi\SyliusVoucherPlugin\Model\VoucherConfigurationInterface;
use Sylius\Component\Resource\Factory\FactoryInterface;

final class VoucherConfigurationFactory implements VoucherConfigurationFactoryInterface
{
    private readonly FactoryInterface $decoratedFactory;

    private readonly FactoryInterface $imageFactory;

    public function __construct(FactoryInterface $decoratedFactory, FactoryInterface $imageFactory)
    {
        $this->decoratedFactory = $decoratedFactory;
        $this->imageFactory = $imageFactory;
    }

    public function createNew(): VoucherConfigurationInterface
    {
        /** @var VoucherConfigurationInterface $configuration */
        $configuration = $this->decoratedFactory->createNew();

        /** @var VoucherConfigurationImageInterface $backgroundImage */
        $backgroundImage = $this->imageFactory->createNew();
        $configuration->setBackgroundImage($backgroundImage);

        return $configuration;
    }
}
