<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Model;

use Sylius\Component\Channel\Model\ChannelInterface as SyliusChannelInterface;
use Sylius\Component\Locale\Model\LocaleInterface;
use Webmozart\Assert\Assert;

class VoucherChannelConfiguration implements VoucherChannelConfigurationInterface
{
    protected ?int $id;

    protected ?SyliusChannelInterface $channel;

    protected ?LocaleInterface $locale;

    protected ?VoucherConfigurationInterface $configuration;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getChannel(): ?SyliusChannelInterface
    {
        return $this->channel;
    }

    public function setChannel(?SyliusChannelInterface $channel): void
    {
        Assert::notNull($channel);
        $this->channel = $channel;
    }

    public function getLocale(): ?LocaleInterface
    {
        return $this->locale;
    }

    public function setLocale(LocaleInterface $locale): void
    {
        $this->locale = $locale;
    }

    public function getConfiguration(): ?VoucherConfigurationInterface
    {
        return $this->configuration;
    }

    public function setConfiguration(VoucherConfigurationInterface $configuration): void
    {
        $this->configuration = $configuration;
    }
}
